<?php
require_once 'PHPUnit/Framework.php';
require_once dirname(__FILE__) . '/../Docudown/Class.php';

abstract class TestAbstractClass {}

/**
	Test documentation
*/
final class ClassTest extends PHPUnit_Framework_TestCase {
	public $class;

	function setUp() {
		$this->class = new Docudown_Class(__CLASS__);
	}

	function testInitializeWithClassNameString() {
		$class = $this->class;

		$this->assertAttributeEquals(__CLASS__, 'name', $class);
		$this->assertEquals(__CLASS__, $class->reflection->getName());
	}

	function testInitializeWithReflectionClass() {
		$class = new Docudown_Class(new ReflectionClass(__CLASS__));

		$this->assertAttributeEquals(__CLASS__, 'name', $class);
		$this->assertEquals(__CLASS__, $class->reflection->getName());
	}

	function testTitle() {
		$this->assertEquals('final class ClassTest', $this->class->title);

		$class = new Docudown_Class('TestAbstractClass');
		$this->assertEquals('abstract class TestAbstractClass', $class->title);
	}

	function testMatches() {
		$this->assertTrue($this->class->matches(__CLASS__));
	}
}

