<?php
require_once 'PHPUnit/Framework.php';
require_once dirname(__FILE__) . '/../Docudown/Element.php';

final class TestElement extends Docudown_Element {
	protected function getKeys() {
		return array('key', 'key2');
	}

	protected function getTitle() {
		return "test elem {$this->reflection->getName()}";
	}
}

final class ElementTest extends PHPUnit_Framework_TestCase {
	function setUp() {
		$this->element = new TestElement(
			new ReflectionMethod($this, 'testPlainText')
		);
	}

	/**
		Test document member.

		`Docudown_Element->plainText` reads from document comment(`/*` ~ `*\/`)
		code of the element.
	*/
	function testPlainText() {
		$this->assertEquals(
			"Test document member.\n\n`Docudown_Element->plainText` reads ".
			"from document comment(`/*` ~ `*/`)\ncode of the element.",
			$this->element->plainText
		);

		$this->assertTrue(isset($this->element->plainText));
	}

	function testTitle() {
		$this->assertEquals('test elem testPlainText', $this->element->title);
	}

	function testKeys() {
		$this->assertEquals(array('key', 'key2'), $this->element->keys);
	}
}

