<?php
require_once 'PHPUnit/Framework.php';
require_once dirname(__FILE__) . '/../Docudown/Package.php';

final class PackageTest extends PHPUnit_Framework_TestCase {
	public $package, $elements;

	function setUp() {
		$this->elements = array(
			new Docudown_Class('PackageTest'),
			new Docudown_Class('Docudown_Package')
		);

		$this->package = new Docudown_Package($this->elements);
	}

	function testInitialize() {
		$package = new Docudown_Package;
		$this->assertEquals(array(), $package->elements);
	}

	function testInitializeWithElements() {
		$this->assertEquals(2, count($this->package->elements));
		$this->assertContains($this->elements[0], $this->package->elements);
		$this->assertContains($this->elements[1], $this->package->elements);
	}

	function testIndex() {
		$this->assertEquals($this->elements[0], $this->package['PackageTest']);

		$this->assertEquals(
			$this->elements[1],
			$this->package['Docudown_Package']
		);

		$this->assertTrue(isset($this->package['PackageTest']));
		$this->assertTrue(isset($this->package['Docudown_Package']));
		$this->assertFalse(isset($this->package['NotExistsClass']));
	}
}

